package com.cxytiandi.springboot_vue_server;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.context.annotation.Configuration;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.cxytiandi.springboot_vue_server.anno.EnableAuth;

@Component
@Configuration
public class ApiAuthDataInit implements ApplicationContextAware {
	public static List<String> checkApis = new ArrayList<String>();

	public void setApplicationContext(ApplicationContext ctx) throws BeansException {
		Map<String, Object> beanMap = ctx.getBeansWithAnnotation(RestController.class);
		if (beanMap != null) {
			for (Object bean : beanMap.values()) {
				Class<?> clz = bean.getClass();
				Method[] methods = clz.getMethods();
				for (Method method : methods) {
					if (method.isAnnotationPresent(EnableAuth.class)) {
						String uri = getApiUri(clz, method);
						System.err.println(uri);
						checkApis.add(uri);
					}
				}
			}
		}
	}

	private String getApiUri(Class<?> clz, Method method) {
		StringBuilder uri = new StringBuilder();
		uri.append(clz.getAnnotation(RequestMapping.class).value()[0]);
		if (method.isAnnotationPresent(GetMapping.class)) {
			uri.append(method.getAnnotation(GetMapping.class).value()[0]);
		} else if (method.isAnnotationPresent(PostMapping.class)) {
			uri.append(method.getAnnotation(PostMapping.class).value()[0]);
		} else if (method.isAnnotationPresent(RequestMapping.class)) {
			uri.append(method.getAnnotation(RequestMapping.class).value()[0]);
		}
		return uri.toString();
	}
}