package com.cxytiandi.springboot_vue_server.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.cxytiandi.encrypt.anno.Decrypt;
import com.cxytiandi.encrypt.anno.Encrypt;
import com.cxytiandi.springboot_vue_server.anno.EnableAuth;
import com.cxytiandi.springboot_vue_server.param.LoginParam;
import com.cxytiandi.springboot_vue_server.po.User;
import com.cxytiandi.springboot_vue_server.service.UserService;
import com.cxytiandi.springboot_vue_server.util.JWTUtils;
import com.cxytiandi.springboot_vue_server.util.UserInfoUtils;

@RestController
@RequestMapping("/user")
public class UserController {

	@Autowired
	private UserService userService;
	
	@PostMapping("/save")
	public Object saveUser(@RequestBody User user) {
//		User user = new User();
//		user.setName("yinjihuan");
//		user.setAge(18);
//		user.setMobile("12111112222");
//		user.setPass("111111");
		user.setStatus(true);
		userService.save(user);
		return true;
	}
	
	@EnableAuth
	@GetMapping("/get")
	public Object get() {
		return userService.get(1);
	}
	
	@Encrypt
	@GetMapping("/list")
	public Object list(HttpServletRequest request, String name) {
		System.out.println("用户ID:" + UserInfoUtils.getLoginUserId(request));
		return userService.list();
	}
	
	@GetMapping("/update")
	public Object update() {
		User user = userService.get(1);
		user.setAge(30);
		userService.update(user);
		return true;
	}
	
	@GetMapping("/remove")
	public Object remove() {
		userService.remove(1);
		return true;
	}
	
	@Encrypt
	@Decrypt
	@PostMapping("/login")
	public Object login(@RequestBody LoginParam param) {
		Map<String, Object> result = new HashMap<String, Object>();
		User user = userService.login(param.getUsername(), param.getPassword());
		if (user != null) {
			result.put("status", true);
			result.put("token", JWTUtils.getInstance().getToken(user.getId()+""));
		} else {
			result.put("status", false);
		}
		return result;
	}
	
}
