package com.cxytiandi.springboot_vue_server.filter;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.util.StringUtils;

import com.cxytiandi.springboot_vue_server.ApiAuthDataInit;
import com.cxytiandi.springboot_vue_server.ResponseData;
import com.cxytiandi.springboot_vue_server.util.JWTUtils;
import com.cxytiandi.springboot_vue_server.util.JsonUtils;
import com.cxytiandi.springboot_vue_server.util.UserInfoUtils;
import com.cxytiandi.springboot_vue_server.util.JWTUtils.JWTResult;

public class ApiFilter implements Filter {

	public void init(FilterConfig filterConfig) throws ServletException {
		
	}

	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain)
			throws IOException, ServletException {
		HttpServletRequest req = (HttpServletRequest) request;
		HttpServletResponse resp = (HttpServletResponse) response;
		resp.setCharacterEncoding("utf-8");
		resp.setContentType("application/json;charset=utf-8");
		String authorization = req.getHeader("Authorization");
		
		if (ApiAuthDataInit.checkApis.contains(req.getRequestURI())) {
			String userId = UserInfoUtils.getLoginUserId(req);
			if (userId == null) {
				PrintWriter writer = resp.getWriter();
				writer.write(JsonUtils.toJson(ResponseData.fail("请先登录")));
				writer.flush();
				return;
			}
		}
		if (StringUtils.hasText(authorization)) {
			System.err.println(req.getRequestURI());
			JWTResult result = JWTUtils.getInstance().checkToken(authorization);
			// 过期
			if (!result.isStatus() && req.getRequestURI().contains("list")) {
				PrintWriter writer = resp.getWriter();
				writer.write(JsonUtils.toJson(result));
				writer.flush();
				return;
			}
		}
		chain.doFilter(request, response);
	}

	public void destroy() {
		
	}

}
