package com.cxytiandi.springboot_vue_server.service;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.transaction.Transactional;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.cxytiandi.springboot_vue_server.po.User;
import com.cxytiandi.springboot_vue_server.repository.UserRepository;

@Service
public class UserServiceImpl implements UserService {

	@Autowired
	private UserRepository userRepository;
	
	@Transactional
	public void save(User user) {
		userRepository.save(user);
	}

	public void update(User user) {
		userRepository.save(user);
	}

	public User get(Integer id) {
		return userRepository.findOne(id);
	}

	public void remove(Integer id) {
		userRepository.delete(id);
	}

	public List<User> list() {
		List<User> list = new ArrayList<User>();
		Iterable<User> it = userRepository.findAll();
		Iterator<User> iter = it.iterator();
		while (iter.hasNext()) {
			list.add(iter.next());
		}
		return list;
	}

	public User login(String username, String password) {
		return userRepository.findByNameAndPass(username, password);
	}

}
